IF NOT exists(SELECT * FROM ct_TransImpExpDataTypesDetail WHERE MnemoName = 'CUSTBONUS')
   INSERT ct_TransImpExpDataTypesDetail (DataTypeid, MnemoName, Type, PK) SELECT 59, 'CUSTBONUS', 5, 0
IF NOT exists(SELECT * FROM ct_TransImpExpDataTypesDetail WHERE MnemoName = 'CUSTBONUSDATE')
   INSERT ct_TransImpExpDataTypesDetail (DataTypeid, MnemoName, Type, PK) SELECT 59, 'CUSTBONUSDATE', 3, 0

IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.ROUTINES WHERE ROUTINE_NAME = 'cp_TransImportCustomer' AND ROUTINE_TYPE='PROCEDURE')
DROP PROCEDURE [dbo].[cp_TransImportCustomer]
GO
CREATE procedure cp_TransImportCustomer
AS
/*
: 5.02.80.01
:  
: 19.03.2010
:     
*/
SET NOCOUNT ON 
DECLARE @mysql varchar(8000)
SET @mysql = '
CREATE index ix1 ON ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' (DISCCARDCUSTCODE,DISCCARDCUSTOMER)
CREATE index ix2 ON ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' (DISCCARDCUSTOMER)

DELETE ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' WHERE (DISCCARDCUSTCODE IS NULL OR DISCCARDCUSTCODE = 0) AND ISNULL(DISCCARDCUSTOMER, '''') = ''''

IF exists(SELECT * FROM ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' WHERE (DISCCARDCUSTCODE = 0 OR DISCCARDCUSTCODE IS null)) 
   UPDATE c 
   SET DISCCARDCUSTCODE = cr.id
   FROM ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' c
      JOIN Customer cr ON LEFT(left(DISCCARDCUSTOMER, ISNULL(NULLIF(charindex('' '',DISCCARDCUSTOMER)-1,-1),50)),50) = cr.Familia AND 
           ISNULL(DISCCARDCUSTFIRSTNAME, 
                  LEFT(LTRIM(REPLACE(SUBSTRING(DISCCARDCUSTOMER, 
                                          charindex('' '',DISCCARDCUSTOMER)+1, 
                                          ABS(charindex('' '',DISCCARDCUSTOMER,charindex('' '',DISCCARDCUSTOMER)+1)-charindex('' '',DISCCARDCUSTOMER))),
                                ''.'','''')),50)) = ISNULL(cr.Ima,'''') AND 
           ISNULL(DISCCARDCUSTMIDDLENAME, 
                  LEFT(LTRIM(REPLACE(SUBSTRING(DISCCARDCUSTOMER, 
                                          charindex('' '',DISCCARDCUSTOMER,charindex('' '',DISCCARDCUSTOMER)+1)+1, 
                                          ABS(charindex(''.'',DISCCARDCUSTOMER,charindex(''.'',DISCCARDCUSTOMER)+1)-charindex('' '',DISCCARDCUSTOMER))),
                                 ''.'','''')),50)) = ISNULL(cr.Otchestvo,'''')
   WHERE 
      DISCCARDCUSTCODE IS NULL OR DISCCARDCUSTCODE = 0


UPDATE 
   cr
SET 
   cr.Familia           = isnull(LEFT(left(DISCCARDCUSTOMER,ISNULL(NULLIF(charindex('' '',DISCCARDCUSTOMER)-1,-1),50)),50), cr.Familia),
   cr.Ima               = coalesce(DISCCARDCUSTFIRSTNAME, 
                                    LEFT(LTRIM(REPLACE(SUBSTRING(DISCCARDCUSTOMER, 
                                                            charindex('' '',DISCCARDCUSTOMER)+1, 
                                                            ABS(charindex('' '',DISCCARDCUSTOMER,charindex('' '',DISCCARDCUSTOMER)+1)-charindex('' '',DISCCARDCUSTOMER))),
                                                  ''.'','''')),50), cr.Ima),
   cr.Otchestvo         = coalesce(DISCCARDCUSTMIDDLENAME, 
                                    LEFT(LTRIM(REPLACE(SUBSTRING(DISCCARDCUSTOMER, 
                                                            charindex('' '',DISCCARDCUSTOMER,charindex('' '',DISCCARDCUSTOMER)+1)+1, 
                                                            ABS(charindex(''.'',DISCCARDCUSTOMER,charindex(''.'',DISCCARDCUSTOMER)+1)-charindex('' '',DISCCARDCUSTOMER))),
                                                   ''.'','''')),50), cr.Otchestvo),
   cr.Phone             = isnull(CUSTPHONE, cr.Phone),
   cr.Algoritm          = isnull(ALGORITHM, cr.Algoritm),
   cr.Women             = isnull(CUSTSEX, cr.Women),
   cr.DateBorn          = CASE 
                              WHEN ISNULL(CUSTDATEBORN, CONVERT(datetime,cr.DateBorn)) < ''19000101'' THEN ''19000101''
                              WHEN ISNULL(CUSTDATEBORN, CONVERT(datetime,cr.DateBorn)) > ''20750101'' THEN ''20750101''
                              ELSE ISNULL(CUSTDATEBORN, CONVERT(datetime,cr.DateBorn)) END,
   cr.VidDoc            = isnull(CUSTDOCTYPE, cr.VidDoc),
   cr.SerDoc            = isnull(CUSTDOCSERIA, cr.SerDoc),
   cr.NumberDoc         = isnull(CUSTDOCNUMBER, cr.NumberDoc),
   cr.Category          = isnull(NULLIF(CUSTCATEGORYCODE,0), cr.Category),
   cr.Status            = isnull(CUSTSTATUS, cr.Status),
   cr.ZIPCode           = isnull(CUSTZIPCODE, cr.ZIPCode),
   cr.City              = isnull(CUSTCITY, cr.City),
   cr.Street            = isnull(CUSTSTREET, cr.Street),
   cr.Home              = isnull(CUSTHOME, cr.Home),
   cr.HomeBody          = isnull(CUSTHOMEBODY, cr.HomeBody),
   cr.Flat              = isnull(CUSTFLAT, cr.Flat),
   cr.Staff             = isnull(CUSTSTAFF, cr.Staff)
FROM 
   customer cr 
   JOIN (select * FROM ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' 
      WHERE DISCCARDCUSTCODE IS NOT NULL AND DISCCARDCUSTCODE != 0) c1 ON c1.DISCCARDCUSTCODE = cr.Id'

EXEC (@mysql)

SET @mysql = '
DECLARE @id INT,@id1 INT
SELECT @id = ISNULL(max(id),0) FROM customer
SELECT @id1 = ISNULL(max(DISCCARDCUSTCODE),0) FROM ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' 
SET @id = case when @id > @id1 THEN @id ELSE @id1 END


INSERT customer
(
      Id,              Familia,        Ima,           Otchestvo,
      Phone,           Women,          DateBorn,      VidDoc,
      SerDoc,          NumberDoc,      Category,      Status,
      ZIPCode,         City,           Street,        Home,  
      HomeBody,        Flat,           Algoritm,      Staff 
)
SELECT Distinct 
   ISNULL(NULLIF(c1.DISCCARDCUSTCODE,0), @id + c1.id),  
   LEFT(left(DISCCARDCUSTOMER, ISNULL(NULLIF(charindex('' '',DISCCARDCUSTOMER)-1,-1),50)),50),
   coalesce(DISCCARDCUSTFIRSTNAME, 
            LEFT(LTRIM(REPLACE(SUBSTRING(DISCCARDCUSTOMER, 
                                    charindex('' '',DISCCARDCUSTOMER)+1, 
                                    ABS(charindex('' '',DISCCARDCUSTOMER,charindex('' '',DISCCARDCUSTOMER)+1)-charindex('' '',DISCCARDCUSTOMER))),
                          ''.'','''')),50)),
  coalesce(DISCCARDCUSTMIDDLENAME, 
            LEFT(LTRIM(REPLACE(SUBSTRING(DISCCARDCUSTOMER, 
                                    charindex('' '',DISCCARDCUSTOMER,charindex('' '',DISCCARDCUSTOMER)+1)+1, 
                                    ABS(charindex(''.'',DISCCARDCUSTOMER,charindex(''.'',DISCCARDCUSTOMER)+1)-charindex('' '',DISCCARDCUSTOMER))),
                           ''.'','''')),50)), 
   c1.CUSTPHONE,             c1.CUSTSEX,                
   CASE 
      WHEN c1.CUSTDATEBORN < ''19000101'' THEN ''19000101''
      WHEN c1.CUSTDATEBORN > ''20750101'' THEN ''20750101''
      ELSE c1.CUSTDATEBORN END,
   c1.CUSTDOCTYPE,            
   c1.CUSTDOCSERIA,          c1.CUSTDOCNUMBER,          NULLIF(c1.CUSTCATEGORYCODE,0),   c1.CUSTSTATUS,             
   c1.CUSTZIPCODE,           c1.CUSTCITY,               c1.CUSTSTREET,         
   c1.CUSTHOME,              c1.CUSTHOMEBODY,           c1.CUSTFLAT,           c1.ALGORITHM,    c1.CUSTSTAFF

FROM 
   ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' c1 
   LEFT JOIN customer ct ON c1.DISCCARDCUSTCODE = ct.Id  
   JOIN (SELECT max(id) id,DISCCARDCUSTCODE FROM ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' GROUP BY DISCCARDCUSTCODE) mc ON mc.id = c1.id OR isnull(c1.DISCCARDCUSTCODE,0) = 0 
WHERE 
   ct.id IS NULL 

IF exists(SELECT * FROM ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' WHERE (DISCCARDCUSTCODE = 0 OR DISCCARDCUSTCODE IS null)) 
   UPDATE c 
   SET DISCCARDCUSTCODE = cr.id
   FROM ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' c
      JOIN Customer cr ON LEFT(left(DISCCARDCUSTOMER, ISNULL(NULLIF(charindex('' '',DISCCARDCUSTOMER)-1,-1),50)),50) = cr.Familia AND 
           ISNULL(DISCCARDCUSTFIRSTNAME, 
                  LEFT(LTRIM(REPLACE(SUBSTRING(DISCCARDCUSTOMER, 
                                          charindex('' '',DISCCARDCUSTOMER)+1, 
                                          ABS(charindex('' '',DISCCARDCUSTOMER,charindex('' '',DISCCARDCUSTOMER)+1)-charindex('' '',DISCCARDCUSTOMER))),
                                ''.'','''')),50)) = ISNULL(cr.Ima,'''') AND 
           ISNULL(DISCCARDCUSTMIDDLENAME, 
                  LEFT(LTRIM(REPLACE(SUBSTRING(DISCCARDCUSTOMER, 
                                          charindex('' '',DISCCARDCUSTOMER,charindex('' '',DISCCARDCUSTOMER)+1)+1, 
                                          ABS(charindex(''.'',DISCCARDCUSTOMER,charindex(''.'',DISCCARDCUSTOMER)+1)-charindex('' '',DISCCARDCUSTOMER))),
                                 ''.'','''')),50)) = ISNULL(cr.Otchestvo,'''')
   WHERE 
      DISCCARDCUSTCODE IS NULL OR DISCCARDCUSTCODE = 0

INSERT 
   #transfercmd
SELECT 
   105, ct.id, 0, s.id 
FROM       
   customer ct 
   JOIN ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' c1 ON c1.DISCCARDCUSTCODE = ct.Id 
   JOIN #shoplist s ON 1 = 1'

EXEC (@mysql)

SET @mysql = '
IF exists(SELECT * FROM ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' WHERE CUSTBONUS IS NOT NULL AND CUSTBONUSDATE IS NOT NULL)
BEGIN
   UPDATE d
   SET Quant = ISNULL(ABS(CUSTBONUS),Quant), Operation = ISNULL(CASE WHEN CUSTBONUS >= 0 THEN 1 ELSE 2 END, Operation)
   FROM 
      CustomerBonusDetail d
      join ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' c1 ON c1.DISCCARDCUSTCODE = d.CustomerId AND 
                                          convert(int,convert(VARCHAR(10),CUSTBONUSDATE,112)) = d.OperDay AND 
                                          d.chequeid = 0

   INSERT CustomerBonusDetail (OperDay, CustomerId, Quant, Operation, ChequeId, Prim, BonusTypeInputing)
   SELECT 
      convert(int,convert(VARCHAR(10),CUSTBONUSDATE,112)),
      DISCCARDCUSTCODE,
      ABS(CUSTBONUS),
      CASE WHEN CUSTBONUS >= 0 THEN 1 ELSE 2 END,
      0,
      '' '', 1
   FROM 
      ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' c1 
      LEFT join CustomerBonusDetail d ON c1.DISCCARDCUSTCODE = d.CustomerId AND 
                                          convert(int,convert(VARCHAR(10),CUSTBONUSDATE,112)) = d.OperDay AND 
                                          d.chequeid = 0
   WHERE 
      d.id IS NULL AND CUSTBONUS IS NOT NULL AND CUSTBONUSDATE IS NOT NULL
END
'

EXEC (@mysql)

SET @mysql = '
IF exists(SELECT * FROM ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' WHERE CUSTBONUS IS NOT NULL AND CUSTBONUSDATE IS NOT NULL)
BEGIN
   INSERT CustomerBuy (OperDay, CustomerId, Summa, BonusIn, BonusOut, Quant)
   SELECT 
      convert(int,convert(VARCHAR(10),CUSTBONUSDATE,112)),
      DISCCARDCUSTCODE,
      0,
      CASE WHEN CUSTBONUS>0 THEN CUSTBONUS ELSE 0 END,
      CASE WHEN CUSTBONUS<=0 THEN CUSTBONUS ELSE 0 END,
      0
   FROM 
      ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' c1 
      LEFT join CustomerBuy d ON c1.DISCCARDCUSTCODE = d.CustomerId AND 
                                          convert(int,convert(VARCHAR(10),CUSTBONUSDATE,112)) = d.OperDay
   WHERE 
      d.OperDay IS NULL AND CUSTBONUS IS NOT NULL AND CUSTBONUSDATE IS NOT NULL

   UPDATE a
   SET a.BonusIn = a.BonusIn+t.BonusIn,
       a.BonusOut = a.BonusOut+t.BonusOut
   FROM CustomerBuy a
     INNER JOIN (
         SELECT
             convert(int,convert(VARCHAR(10),CUSTBONUSDATE,112)) operday,
             DISCCARDCUSTCODE,
             SUM(CASE WHEN CUSTBONUS>0 THEN CUSTBONUS ELSE 0 END) BonusIn,
             SUM(CASE WHEN CUSTBONUS<=0 THEN CUSTBONUS ELSE 0 END) BonusOut
         FROM
             ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' c1 
         WHERE 
             CUSTBONUS IS NOT NULL AND CUSTBONUSDATE IS NOT NULL
         GROUP BY
             convert(int,convert(VARCHAR(10),CUSTBONUSDATE,112)),
             DISCCARDCUSTCODE) t ON t.DISCCARDCUSTCODE = a.CustomerId AND t.operday = a.operday

   INSERT CustomerBonusRest
   (
     OperDay,
     CustomerId
   )
   SELECT 
     convert(int,convert(VARCHAR(10),a.CUSTBONUSDATE,112)),
     a.DISCCARDCUSTCODE
   FROM ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' a 
      LEFT JOIN CustomerBonusRest  b ON a.DISCCARDCUSTCODE = b.CustomerId AND
                                        convert(int,convert(VARCHAR(10),a.CUSTBONUSDATE,112)) = b.Operday
   WHERE 
      b.operday IS NULL AND CUSTBONUS IS NOT NULL AND CUSTBONUSDATE IS NOT NULL
   
   UPDATE 
         r
   SET
         r.BonusIn = ISNULL(r.BonusIn,0) + CASE WHEN CUSTBONUS>0 THEN CUSTBONUS ELSE 0 END
   FROM
         CustomerBonusRest r 
         JOIN ##CUSTOMER' + LTRIM(STR(@@SPID, 19)) + ' b ON
             b.DISCCARDCUSTCODE = r.CustomerId AND
             convert(int,convert(VARCHAR(10),b.CUSTBONUSDATE,112))    = r.Operday

END

--drop table ##CUSTOMER' + LTRIM(STR(@@SPID, 19))
EXEC (@mysql)
GO
